SELECT * FROM `product_purchases`
INNER JOIN `users` ON `user_id` = `users`.`id`
INNER JOIN `product_purchase_lines` ON `product_purchase_id` = `product_purchases`.`id`
INNER JOIN `products` ON `product_id` = `products`.`id`
;

SELECT `users`.`name`, `product_sales`.`created_on`, `products`.`name`, `product_sale_prices`.`valid_from`, `product_sale_lines`.`amount`, `product_sale_prices`.`price`,
`product_sale_lines`.`amount` * `product_sale_prices`.`price` AS `total`
FROM `product_sales`
INNER JOIN `users` ON `user_id` = `users`.`id`
INNER JOIN `product_sale_lines` ON `product_sale_id` = `product_sales`.`id`
INNER JOIN `products` ON `product_sale_lines`.`product_id` = `products`.`id`
INNER JOIN (
    SELECT `product_sale_prices`.`product_id`, MAX(`valid_from`) AS `valid_from`
    FROM `product_sales`
    INNER JOIN `product_sale_lines` ON `product_sale_id` = `product_sales`.`id`
    INNER JOIN `products` ON `product_id` = `products`.`id`
    INNER JOIN `product_sale_prices` ON `product_sale_prices` .`product_id` = `products`.`id` AND `product_sales`.`created_on` > `product_sale_prices`.`valid_from`
    GROUP BY `product_sale_prices`.`product_id`
) AS `product_sale_prices_max` ON `products`.`id` = `product_sale_prices_max`.`product_id`
INNER JOIN `product_sale_prices` ON `product_sale_prices` .`product_id` = `product_sale_prices_max`.`product_id`
	AND `product_sale_prices` .`valid_from` = `product_sale_prices_max`.`valid_from`
;

SELECT `products`.*, `product_sale_prices`.`price`, `stock`.`stock` FROM `products`
INNER JOIN (
	SELECT `product_sale_prices`.*
	FROM `product_sale_prices`
	INNER JOIN (
		SELECT `product_sale_prices`.`product_id`, MAX(`valid_from`) AS `valid_from`
		FROM `product_sale_prices`
		WHERE `valid_from` <= NOW()
		GROUP BY `product_id`
	) `product_sale_prices_max` ON `product_sale_prices`.`product_id` = `product_sale_prices_max`.`product_id`
		AND `product_sale_prices`.`valid_from` = `product_sale_prices_max`.`valid_from`
) AS `product_sale_prices` ON `product_sale_prices`.`product_id` = `products`.`id`
INNER JOIN (
	SELECT * 
	FROM (
		SELECT `product_purchase_lines`.`product_id`,  (`amount` - COALESCE(`sale`, 0)) AS `stock`
		FROM `product_purchase_lines`
		LEFT JOIN (
			SELECT `product_id`, SUM(`amount`) AS `sale`
			FROM `product_sale_lines`
			GROUP BY `product_id`
		) AS `product_sale_lines` ON `product_sale_lines`.`product_id` = `product_purchase_lines`.`product_id`
		GROUP BY `product_purchase_lines`.`product_id`
	) AS `stock`
	WHERE `stock` > 0
) AS `stock` WHERE `stock`.`product_id` = `products`.`id`
;
